searchData={"items":[{"type":"module","title":"rebar3_hex_build","doc":"rebar3 hex build - Build packages and docs Builds a new local version of your package. By default this provider will build both a package tarball and docs tarball. The package and docs .tar files are created in the current directory, but is not pushed to the repository. An app named foo at version 1.2.3 will be built as foo-1.2.3.tar. Likewise the docs .tar would be built as foo-1.2.4-docs.tar. $ rebar3 hex build You may also build only a package or docs tarball utilizing the same available command line options. $ rebar3 hex build package $ rebar3 hex build docs Configuration Packages are configured via src/&lt;myapp&gt;.app.src attributes. Required configuration application - application name. This is required per Erlang/OTP thus it should always be present anyway. vsn - must be a valid semantic version identifier. licenses - A list of licenses the project is licensed under. This attribute is required and must be a valid spdx identifier. Optional configuration In addition, the following meta attributes are supported and highly recommended : description - a brief description about your application. pkg_name - The name of the package in case you want to publish the package with a different name than the application name. links - A map where the key is a link name and the value is the link URL. Optional but highly recommended. files - A list of files and directories to include in the package. Defaults to standard project directories, so you usually don't need to set this property. include_paths - A list of paths containing files you wish to include in a release. exclude_paths - A list of paths containing files you wish to exclude in a release. exclude_patterns - A list of regular expressions used to exclude files that may have been accumulated via files and include_paths and standard project paths. build_tools - List of build tools that can build the package. It's very rare that you need to set this. Below is an example : { application , myapp , [ { description , &quot;An Erlang/OTP application&quot; } , { vsn , &quot;0.1.0&quot; } , { modules , [ ] } , { registered , [ ] } , { applications , [ kernel , stdlib , ] } , { licenses , [ &quot;Apache-2.0&quot; ] } , { links , [ { &quot;GitHub&quot; , &quot;https://github.com/my_name/myapp&quot; } ] } ] } . Command line options -r , --repo - Specify the repository to work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ). Defaults to hexpm . -u , --unpack - Builds the tarball and unpacks contents into a directory. Useful for making sure the tarball contains all needed files before publishing. See --output below for setting the output path. -o , --output - Sets output path. When used with --unpack it means the directory (Default: &lt;app&gt;-&lt;version&gt; ). Otherwise, it specifies tarball path (Default: &lt;app&gt;-&lt;version&gt;.tar ). Artifacts will be written to _build/&lt;profile&gt;/lib/&lt;your_app&gt;/ by default.","ref":"rebar3_hex_build.html"},{"type":"function","title":"rebar3_hex_build.doc_opts/2","doc":null,"ref":"rebar3_hex_build.html#doc_opts/2"},{"type":"module","title":"rebar3_hex_cut","doc":"rebar3 hex cut - Publish with git tag and version bump features Increments tags and publishes. Incrementing and tagging are both optional features of this provider. By default you'll be prompted what type of increment to make to the version or it can be supplied as an argument to the command -i , --increment switch. cut will also optionally create version bump commit, create a tag with a name corresponding to the new version, and prompt you if you'd like to push the tag up to your git repository. You may opt-out of prefixing tags and commits with a v prefix (i.e., v1.2.3) using --prefix-tag false switch. Below is a full example of cut in action : rebar3 hex cut == =&gt; Analyzing applications . . . == =&gt; Verifying dependencies . . . Select semver increment or other ( Current 0.1 . 3 ) : 1 ) patch 2 ) minor 3 ) major 4 ) other [ 1 - 4 ] &gt; 1 Create &#39;v0.1.4&#39; commit ? ( &quot;Y&quot; ) &gt; Push master to origin master ? ( &quot;N&quot; ) &gt; Local Password : Publishing myapp 0.1 . 4 to hexpm : myrepo Description : My Application Dependencies : relx ~ &gt; 4.5 . 0 Included files : LICENSE README . md rebar . config src / myapp . app . src src / myapp . erl Licenses : Apache - 2.0 Links : github : https : / / github . com / myname / myapp Build tools : rebar3 Before publishing , please read Hex CoC : https : / / hex . pm / policies / codeofconduct Proceed ( with warnings ) ? ( &quot;Y&quot; ) &gt; == =&gt; Published myapp 0.1 . 4 == =&gt; Analyzing applications . . . == =&gt; Compiling myapp == =&gt; Running edoc for myapp == =&gt; Running ex_doc for myapp == =&gt; Published docs for myapp 0.1 . 4 Create new git tag v0 . 1.4 ? ( &quot;Y&quot; ) &gt; == =&gt; Creating new tag v0 . 1.4 . . . Push new tag to origin ? ( &quot;Y&quot; ) &gt; == =&gt; Pushing new tag v0 . 1.4 . . . --repo - Specify the repository to work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ). Defaults to hexpm . -i , --increment - Specify the type of version increment to perform without being prompted at runtime. Supported types are : major minor patch","ref":"rebar3_hex_cut.html"},{"type":"module","title":"rebar3_hex_organization","doc":"rebar3_hex_organization - Manage organizations Manages the list of authorized hex organizations. Note that all commands that require a NAME argument expect a qualified repository name for the argument (i.e., hexpm:my_org ). About Organizations Organizations are feature provided by hexpm that allows you group packages, public and private alike. Organizations are treated as repositories that have a parent. The parent is found as the first part of a repository's name, separated from the organization by a : . So for the organization your_org on the main repository hexpm the fully qualified name would be hexpm:your_org . Be sure to add your organization to either your global rebar.config ~/.config/rebar3/rebar.config or within an projects rebar.config . Below is an example: { hex , [ { repos , [ #{ name =&gt; &lt;&lt; &quot;hexpm:your_org&quot; &gt;&gt; } ] } ] } . Authorize an organization This command will generate an API key used to authenticate access to the organization. See the rebar3_hex_user tasks to list and control all your active API keys. $ rebar3 hex organization auth NAME [ -- key KEY ] [ -- key - name KEY_NAME ] Deauthorize and remove an organization $ rebar3 hex organization deauth NAME List all authorized organizations This command will only list organizations you have authorized with this task, it will not list organizations you have access to by having authorized with rebar3 hex user auth . Generate organization key This command is useful to pre-generate keys for use with rebar3 hex organization auth NAME --key KEY on CI servers or similar systems. It returns the hash of the generated key that you can pass to auth NAME --key KEY. Unlike the hex user key commands, a key generated with this command is owned by the organization directly, and not the user that generated it. This makes it ideal for shared environments such as CI where you don't want to give access to user-specific resources and the user's organization membership status won't affect key. By default this command sets the organization permission which allows read-only access to the organization, it can be overridden with the --permission flag. $ rebar3 hex organization key NAME generate [ -- key - name KEY_NAME ] [ -- permission PERMISSION ] Revoke key Removes a given key from a organization. $ rebar3 hex organization key NAME revoke KEY_NAME List keys Lists all keys associated with the organization. $ rebar3 hex organization key NAME list Command line options --all - Used for revoking all keys for authorized organization. Only valid with the revoke` task.&lt;/li&gt; &lt;li&gt;`--key KEY - Hash of key used to authenticate HTTP requests to organization, if omitted will generate a new key with your account credentials. This flag is useful if you have a key pre-generated with rebar3 hex organization key and want to authenticate on a CI server or similar system. --key-name KEY_NAME - By default Hex will base the key name on your machine's hostname and the organization name, use this option to give your own name. --permission PERMISSION - Sets the permissions on the key, this option can be given multiple times, possibly values are: api:read - API read access. api:write - API write access. repository - Access to the repository (this is the default permission).","ref":"rebar3_hex_organization.html"},{"type":"module","title":"rebar3_hex_owner","doc":"rebar3 hex owner - Manage package owners Adds, removes or lists package owners. Package owners have full permissions to the package. They can publish and revert releases and even remove other package owners. Add a owner Adds an owner to package by specifying the package name and email or username of the new owner. $ rebar3 hex owner add PACKAGE EMAIL_OR_USERNAME Transfer ownership Like rebar3 hex owner add` add but also removes all existing owners of the package. This task is required to use when transferring ownership of the package to an organization. ``` $ rebar3 hex owner transfer PACKAGE EMAIL_OR_USERNAME '' Remove owner Removes an owner to package by specifying the package name and email or username of the new owner. $ rebar3 hex owner remove PACKAGE EMAIL_OR_USERNAME List owners Lists all owners of given package. $ rebar3 hex owner list PACKAGE List owned packages Lists all packages owned by the current user. $ rebar3 hex owner list packages Command line options --repo - Specify the repository to work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ). Defaults to hexpm . --level - Specify the ownership level, either full or maintainer . Both ownership levels allow publishing and retiring of packages. However, only an owner with full access may add, remove other owners, or transfer a package to another owner. Defaults to full .","ref":"rebar3_hex_owner.html"},{"type":"module","title":"rebar3_hex_publish","doc":"rebar3 hex publish - publish packages and docs Builds and publishing a new version of a package and docs. $ rebar3 hex publish The current authenticated user will be the package owner. Only package owners can publish the package, new owners can be added with the rebar3 hex owner task. Packages and documentation sizes are limited to 8mb compressed, and 64mb uncompressed. By default this provider will build both a package tarball and docs tarball. Before attempting to publish your package see the section below on documentation. Publishing Documentation By default rebar3_hex will not generate or publish docs. You must add a doc provider to your the hex config in either your global rebar.config (i.e., ~/.config/rebar3/rebar.config ) or locally in a projects rebar.config . We recommend using rebar3_ex_doc for publishing documentation along with your package for a consistent format and style on hexpm. Example : { ex_doc , [ { source_url , &lt;&lt; &quot;https://github.com/namespace/your_app&quot; &gt;&gt; } , { extras , [ &lt;&lt; &quot;README.md&quot; &gt;&gt; , &lt;&lt; &quot;LICENSE&quot; &gt;&gt; ] } , { main , &lt;&lt; &quot;readme&quot; &gt;&gt; } ] } . { hex , [ { doc , ex_doc } ] } . Alternatively you can use the edoc provider that ships with rebar3 : erlang { hex , [ { doc , edoc } ] } . The expected result of the task is the generated documentation located in the either doc/ directory with an index.html file or the directory you have configured the documentation provider to use. The documentation will be accessible at https://hexdocs.pm/my_package/1.0.0 , https://hexdocs.pm/my_package will always redirect to the latest published version. When a doc provider is configured documentation will be built and published automatically. To publish a package without documentation run mix rebar3 hex publish package or to only publish documentation run rebar3 hex publish docs . Reverting a package A new package can be reverted or updated within 24 hours of it's initial publish, a new version of an existing package can be reverted or updated within one hour. Documentation have no limitations on when it can be updated. To update the package simply run the rebar hex publish task again. To revert run rebar3 hex publish --revert VERSION or to only revert the documentation run rebar3 hex publish docs --revert VERSION . If the last version is reverted, the package is removed. Command line options -a , --app - Specify which app you want to publish without being prompted to choose. This option is required when reverting a package, otherwise it's only useful in the context of an umbrella. -r , --repo - Specify the repository work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ). Defaults to hexpm . -y , --yes - Publishes the package without any confirmation prompts --replace - Allows overwriting an existing package version if it exists. Private packages can always be overwritten, public packages can only be overwritten within one hour after they were initially published. --revert VERSION - Revert the given version. If the last version is reverted, the package is removed. --dry-run - Performs a dry run of the publish task (i.e., it won't actually publish). --doc-dir - The option may be used in case there is no doc provider available for your desired method of generating documentation. Instead of finding and running a doc provider, rebar3_hex will simply gather the files specified in the directory given to this option. Be sure your docs are up to date before publishing with this option.","ref":"rebar3_hex_publish.html"},{"type":"function","title":"rebar3_hex_publish.do/1","doc":null,"ref":"rebar3_hex_publish.html#do/1"},{"type":"function","title":"rebar3_hex_publish.format_error/1","doc":null,"ref":"rebar3_hex_publish.html#format_error/1"},{"type":"function","title":"rebar3_hex_publish.init/1","doc":null,"ref":"rebar3_hex_publish.html#init/1"},{"type":"function","title":"rebar3_hex_publish.publish/4","doc":null,"ref":"rebar3_hex_publish.html#publish/4"},{"type":"function","title":"rebar3_hex_publish.publish_docs/4","doc":null,"ref":"rebar3_hex_publish.html#publish_docs/4"},{"type":"function","title":"rebar3_hex_publish.publish_package/4","doc":null,"ref":"rebar3_hex_publish.html#publish_package/4"},{"type":"module","title":"rebar3_hex_retire","doc":"rebar3 hex retire - retire and unretire packages Retires a package version. $ rebar3 hex retire PACKAGE VERSION REASON -- message $ rebar3 hex retire PACKAGE VERSION -- unretire Mark a package as retired when you no longer recommend it's usage. A retired package is still resolvable and usable but it will be flagged as retired in the repository and a message will be displayed to users when they use the package. Retirement reasons renamed - The package has been renamed, including the new package name in the message. deprecated - The package has been deprecated, if there's a replacing package include it in the message security - There are security issues with this package invalid - The package is invalid, for example it does not compile correctly other - Any other reason not included above, clarify the reason in the message Command line options --repo - Specify the repository to work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ).","ref":"rebar3_hex_retire.html"},{"type":"module","title":"rebar3_hex_search","doc":"rebar3 hex search - search for packages on hexpm. Displays packages matching the given search query. If you are authenticated it will additionally search all organizations you are member of. $ rebar3 hex search PACKAGE Command line options --repo - Specify the repository to work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ). Defaults to hexpm .","ref":"rebar3_hex_search.html"},{"type":"module","title":"rebar3_hex_user","doc":"rebar3 hex user - Hex user tasks. Register a user $ rebar3 hex user register Print the current user $ rebar3 hex user whoami Authorize a new user $ rebar3 hex user auth [ -- key - name KEY_NAME ] Deauthorize the user Deauthorizes the user from the local machine by removing the API key from the Hex config. $ rebar3 hex user deauth Generate user key Generates an unencrypted API key for your account. Keys generated by this command will be owned by you and will give access to your private resources, do not share this key with anyone. For keys that will be shared by organization members use rebar3 hex organization key instead. By default this command sets the api:write permission which allows write access to the API, it can be overridden with the --permission flag. $ rebar3 hex user key generate [ -- key - name KEY_NAME ] [ -- permission PERMISSION ] Revoke key Removes given key from account. The key can no longer be used to authenticate API requests. $ rebar3 hex user key revoke NAME KEY_NAME Revoke all keys Revoke all keys from your account. $ rebar3 hex user key revoke -- all List keys Lists all keys associated with the organization. $ rebar3 hex user key list Reset user account password Starts the process for resetting account password. rebar3 hex user reset_password account Reset local password rebar3 hex user reset_password local Command line options --repo - Specify the repository to work with. This option is required when you have multiple repositories configured, including organizations. The argument must be a fully qualified repository name (e.g, hexpm , hexpm:my_org , my_own_hexpm ). Default to hexpm . --message &quot;MESSAGE&quot; - Required message (up to 140 characters) clarifying the retirement reason --key-name KEY_NAME - By default Hex will base the key name on your machine's hostname and the organization name, use this option to give your own name. --permission PERMISSION - Sets the permissions on the key, this option can be given multiple times, possible values are: api:read - API read access. api:write - API write access. repository:ORGANIZATION_NAME - Access to the repository (this is the default permission). repositories - Access to repositories for all organizations you are member of.","ref":"rebar3_hex_user.html"},{"type":"extras","title":"rebar3_hex","doc":"# rebar3_hex\n\n[![Build Status](https://github.com/erlef/rebar3_hex/actions/workflows/ci.yml/badge.svg)](https://github.com/erlef/rebar3_hex/actions/workflows/ci.yml) \n[![Hex pm](https://img.shields.io/hexpm/v/rebar3_hex.svg)](https://hex.pm/packages/rebar3_hex)\n[![Docs](https://img.shields.io/badge/hex-docs-green.svg?style=flat)](https://hexdocs.pm/rebar3_hex)\n[![Erlang Versions](https://img.shields.io/badge/Supported%20Erlang%2FOTP-22.0%20to%2024.0-blue)](http://www.erlang.org)\n\nrebar3_hex is a plugin for [Rebar3](https://www.rebar3.org/) that bundles providers to interact with [Hex](https://hex.pm/).\n\n> 💡 **rebar3_hex is a tool for package authors**  \n> If your Erlang project is not meant to be published on Hex, Rebar3 itself should be enough for you.","ref":"readme.html"},{"type":"extras","title":"Setup - rebar3_hex","doc":"Add to your global rebar3 config in `~/.config/rebar3/rebar.config`:\n\n```erlang\n{plugins, [rebar3_hex]}.\n```\n\nAlternatively, you can add to your project's rebar3 config in project plugins : \n\n```erlang\n{project_plugins, [rebar3_hex]}.\n```\n\n**NOTE** : Be sure **not** to add `rebar3_hex` to the plugins section within a projects rebar3 config as this will \nbecome a dependency for others downloading your package from hex.pm","ref":"readme.html#setup"},{"type":"extras","title":"Documentation - rebar3_hex","doc":"rebar3_hex by default expects you to configure a documentation provider. We recommend using\n[rebar3_ex_doc](https://hexdocs.pm/rebar3_ex_doc/) for publishing documentation along with your package for a \nconsistent format and style on [hex.pm](https://hex.pm/). \n\nExample : \n\n```erlang\n\n{ex_doc, [\n    {extras, [\"README.md\", \"LICENSE\"]},\n    {main, \"README.md\"},\n    {source_url, \"https://github.com/namespace/your_app\"}\n]}.\n\n{hex, [{doc, ex_doc}]}.\n```\n\nAlternatively, or on Erlang versions older than OTP-24, you can use the edoc provider that ships with rebar3 : \n\n```erlang\n{hex, [{doc, edoc}]}.\n```","ref":"readme.html#documentation"},{"type":"extras","title":"Basic usage - rebar3_hex","doc":"You should read the [docs](https://hexdocs.pm/rebar3_hex/) for a complete over for each provider, but below is a\nbrief overview of basic usage.","ref":"readme.html#basic-usage"},{"type":"extras","title":"Authenticating User - rebar3_hex","doc":"If you already have a user for [hex.pm](https://hex.pm) run:\n\n\n```shell\n$ rebar3 hex user auth\n```\n\nNote that this will ask for your hex.pm username and password, as well as a password for encrypting your api token that \nhas write permissions to the repository. When publishing a package you will have to give this password to decrypt the \ntoken in order to publish.\n\nSee the [docs](https://hexdocs.pm/rebar3_hex/rebar3_hex_user.html) for more information.","ref":"readme.html#authenticating-user"},{"type":"extras","title":"Building - rebar3_hex","doc":"The `build` provider is very useful for seeing exactly what would be published using either the `publish` or `cut` task\nwithout any chance of actually publishing the package or docs. Tarballs for the package and docs are written to\n`_build/ /lib/your_app/hex/` by default. \n\n\n```\n$ rebar3 hex build\n```\n\nSee the [docs](https://hexdocs.pm/rebar3_hex/rebar3_hex_build.html) for more information.","ref":"readme.html#building"},{"type":"extras","title":"Publishing - rebar3_hex","doc":"Two providers are available for publishing packages, `publish` and `cut` \n\nBy default `publish` builds and pushes your package and docs to a repository. See the \n[docs](https://hexdocs.pm/rebar3_hex/rebar3_hex_publish.html) for more information. \n\n``` shell\n$ rebar3 hex publish\n```\n\n`cut` is available to provide some additional functionality around versioning and git tags. See the \n[docs](https://hexdocs.pm/hex/rebar3_hex_cut.html) for more information.\n\n``` shell\n$ rebar3 hex cut\n```\n\nIn either case, both providers will display the details of what is being published \n(what files, the version, dependencies) and ask if it should continue, so be sure to read the \noutput carefully and make sure it is publishing what you expected.","ref":"readme.html#publishing"},{"type":"extras","title":"Managing package owners - rebar3_hex","doc":"Owners can be added, removed, and listed for packages you are an owner of with the `hex owner` command. Packages\ncan also be transfered to other registered users on hexpm as well. \n\n``` shell\n$ rebar3 hex owner [add | remove | list | transfer]    \n```\n\nSee the [docs](https://hexdocs.pm/rebar3_hex/rebar3_hex_owner.html) for more information.","ref":"readme.html#managing-package-owners"},{"type":"extras","title":"Retiring packages - rebar3_hex","doc":"Packages can be flagged as retired on hexpm via the `retire` provider : \n\n```\n$ rebar3 hex retire PACKAGE VERSION REASON --message\n```\n\nThey can also be unretired in case a mistake was made : \n\n```\n$ rebar3 hex retire PACKAGE VERSION --unretire \n```\n\nSee the [docs](https://hexdocs.pm/rebar3_hex/rebar3_hex_retire.html) for more information.","ref":"readme.html#retiring-packages"},{"type":"extras","title":"Organizations - rebar3_hex","doc":"rebar3_hex supports working with organizations via the `organization` provider. \n\nSimply add your organization to either your global rebar.config (i.e., `~/.config/rebar3/rebar.config` ) or a local\nproject rebar.config. \n\n```erlang\n{hex, [{repos, [#{name => <<\"hexpm:your_org\">>}]}]}.\n```\n\nYou can then authenticate with with the organization repository. Be sure you have already authenticated with the main\nrepository first:\n\n```\n$ rebar3 hex auth    # make sure you're authenticated to the main repo first \n$ rebar3 hex organization auth hexpm:your_org  # authenticate to the org\n```\n\nNow you can generate, revoke, and list keys for your organizations. See below for an example of generating a key for use\nin CI.\n\nSee the [docs](https://hexdocs.pm/rebar3_hex/rebar3_hex_organization.html) for more information.\n\n#### Read-Only Repo Key for CI\n\nIf you have a private organization or other private repository it is recommended that you use a repo specific \nauth token for reading from the repository in CI. To generate a token:\n\n```shell\n$ rebar3 hex organization auth hexpm:myrepo\nSuccessfully authenticated to hexpm:myrepo\n```\n\nNow you can generate a key to use in CI for your organization \n\n```\n$ rebar3 hex organization key hexpm:myrepo generate\nabc123\n```\n\nThen in CI use whatever method is available for setting an environment variable to the token and add this call at the \nbeginning of your CI runs to add the token to your rebar3 hex config. Below we'll use the environment `REPO_KEY` as an\nexample. \n\n```shell\n$ rebar3 hex organization auth hexpm:myrepo --key $REPO_KEY\n```","ref":"readme.html#organizations"},{"type":"extras","title":"Searching hexpm - rebar3_hex","doc":"A `search` provider is available to search packages across hex.pm as a convenience.\n\n```\n$ rebar3 hex search\n```\n\n# Further reading \nSee [Publishing packages](https://hex.pm/docs/rebar3-publish) on hexpm for more setup and usage instructions. See the \n[docs](https://hexdocs.pm/rebar3_hex) for detailed documentation for all available providers.","ref":"readme.html#searching-hexpm"},{"type":"extras","title":"LICENSE","doc":"All rights reserved.\n\n                                Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   Copyright (c) 2015, Tristan Sloughter  .\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}